#include <bits/stdc++.h>
#define long long long int
#define DEBUG
using namespace std;

// @author: pashka

vector<bool> prime;

void gen(int n, int last, string s) {
    if (n >= last && !prime[n]) {
        string res = s + to_string(n);
        cout << res << "\n";
    }
    for (int x = last; x < n; x++) {
        if (prime[x]) continue;
        gen(n - x, x, s + to_string(x) + "+");
    }
}

int main() {
    ios::sync_with_stdio(false);


    int n;
    cin >> n;
    prime.assign(n + 1, true);
    prime[1] = false;
    for (int i = 2; i <= n; i++) {
        if (prime[i]) {
            for (int j = i + i; j <= n; j += i) {
                prime[j] = false;
            }
        }
    }
    gen(n, 1, "");

    return 0;
}