#include <bits/stdc++.h>
#define long long long int
#define DEBUG
using namespace std;

// @author: pashka

int k;
map<pair<pair<int, int>, pair<int, int>>, long> mem;

long go(pair<int, int> n, pair<int, int> last) {
    if (n == make_pair(0, 0)) {
        return 1;
    }
    if (mem.find({n, last}) != mem.end()) {
        return mem[{n, last}];
    }
    long res = 0;
    if (last.first <= n.first && last.second <= n.second)
        res += go({n.first - last.first, n.second - last.second}, last);
    auto next = last;
    if (next.second == k) {
        next.first++;
        next.second = 0;
    } else {
        next.second++;
    }
    if (last.first <= k) {
        res += go(n, next);
    }
    mem[{n, last}] = res;
    return res;
}

int main() {
    ios::sync_with_stdio(false);

    long n;
    cin >> n;
    k = 1;
    for (long p = 2; p * p * p * p <= n; p++) {
        if (n % (p * p) == 0) {
            k = 0;
            while (n % p == 0) {
                k++;
                n /= p;
            }
            break;
        }
    }
    cout << go({k, k}, {0, 1}) - 1 << "\n";

    return 0;
}