def cut_ropes(n, k, q, queries):
    lengths = [n]
    for _ in range(k):
        max_len = lengths[0]
        lengths = lengths[1:]
        if max_len % 2 == 0:
            lengths.extend([max_len // 2, max_len // 2])
        else:
            lengths.extend([max_len // 2, max_len // 2 + 1])
        lengths.sort(reverse=True)
    
    result = []
    for query in queries:
        result.append(lengths[query - 1])
    
    return result

n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))

result = cut_ropes(n, k, q, queries)
print(' '.join(map(str, result)))